#include "sgx_eid.h"
#include "sgx_tcrypto.h"
#include "Decryptor_t.h"
#include "error_codes.h"
#include "sgx_thread.h"
#include "sgx_dh.h"
#include <map>
#include "sgx_tcrypto.h"
#include "LocalAttestationCode_t.h"
#include "sgx_tseal.h"
#include "Openssl_crypto.h"
#include "ECDSASignatureBox.h"
#include "HybridEncryptionBox.h"
#include "LocalAttestationTrusted.h"
#include "sgx_tseal.h"

class Decryptor {
  static ECDSASignatureBox signatureBox;
  static HybridEncryptionBox hybridEncryptionBoxClient;
  static LocalAttestationTrusted localAttestation;

  static uint32_t create_mitigator_token_M(uint8_t* token);
  static uint32_t create_mitigator_header_H(uint8_t* signature_data, uint8_t* signature);
  static uint32_t create_long_term_signing_keypair(uint8_t* private_public_key_string);
  static uint32_t initialize_symmetric_key_decrypt_client_data(uint8_t* plaintext_client_public_key_plus_encrypted_data_plus_tag, uint32_t total_length, uint8_t* plaintext_client_data, uint32_t* plaintext_client_data_length);
  public:
//    Decryptor(): signatureBox(), hybridEncryptionBoxClient(), localAttestation();
//    ~Decryptor();
    static uint32_t create_and_seal_long_term_signing_key_pair(uint32_t* sealed_data_length, uint8_t* sealed_data);
    static uint32_t create_and_encrypt_mitigator_header_H(uint8_t* ciphertext_token_H_plus_tag);
    static uint32_t unseal_and_restore_long_term_signing_key_pair(uint8_t* sealed_data, uint32_t* sgx_sealed_data_length);
    static uint32_t decrypt_verifiers_message_set_apache_mrsigner(uint8_t* ciphertext_plus_tag);
    static uint32_t process_apache_message_generate_response(uint8_t* input_ciphertext, uint32_t input_ciphertext_plus_tag_length, uint8_t* output_ciphertext, uint32_t* output_ciphertext_plus_tag_length);
  };
